! This program writes out the 1D corrugation reduction function based on the
! data from the top site.

PROGRAM Make_1Dcorr

USE Spline

IMPLICIT NONE

DOUBLE PRECISION :: dz1, dz2
INTEGER          :: i, j
DOUBLE PRECISION :: x0, dx0
TYPE (Spline1D)  :: TestSpline

! Read the data
OPEN( 100, FILE="FILE.1d", STATUS="OLD" )

READ(100, *) TestSpline%NX
READ(100, *) dz1
READ(100, *) dz2

CALL Allocate_Spline1D( TestSpline, TestSpline%NX )

j = 0
DO i = 1, TestSpline%NX
  READ(100, *) TestSpline%X(j + 1), TestSpline%F(j + 1)
  ! Only read data for r >= 0.0
  IF ( TestSpline%X(j + 1) .GE. 0.0 ) THEN
    j = j + 1
  END IF
END DO

CLOSE( 100 )

! Correct for the points we threw away
TestSpline%NX = j

! Read data on x = 0
OPEN( 100, FILE="TOP_0", STATUS="OLD" )
READ(100, *) x0, dx0
CLOSE( 100 )

CALL Compute_Spline1D( TestSpline, 2, dx0, 2, 0.0 )

! Rewrite the data
OPEN( 100, FILE="FILE.1d", STATUS="unknown" )
WRITE(100, *) dx0, " DZ1"
WRITE(100, *) "0.0 DZ2"
WRITE(100, *) TestSpline%NX, " NZ"
DO i = 1, TestSpline%NX
  WRITE(100, "(F10.6,F18.10)") TestSpline%X(i), TestSpline%F(i)
END DO
CLOSE( 100 )

END PROGRAM

