#!/usr/bin/python
import time, os, LGI;
import math, sys;

def create_poscar_file(location, Z, r):
    #CREATE A POSCAR FILE
    #input: a3D [A](double) -- Supercell [int] -- layers [int] -- vacuum distance [A](int)  -- fix -- layerpositions [] [] []... -- Atom/Molecule -- u -- v -- t -- p -- Z -- r 
    #string = "./pes 3.63999 3 6 20 fix 0.00000 2.10154 4.19923 6.30387 8.40225 10.49567 Molecule %s %1.5f %1.5f > POSCAR" %(location, Z, r); #B86SRP68
    string = "./pes 4.1632 3 6 20 fix 0.00000 2.437501 4.83235 7.231735 9.627066 12.064678 Atom %s %1.5f %1.5f > POSCAR" %(location, Z, r); #Au-B86SRP68
    print "string= ", string; 
    os.system(string) #this is the commandline, executing the command in varibale string --> creating a POSCAR file using the desirec input
    print 

# FUNCTION ENDS HERE
#----------------------------------------------------------------------------------------------------------

def check_finished(CURRENT_DIRECTORY, Client, functional ):
    print "Entering check_finished function...."
    print "Current date & time " + time.strftime("%c")

    LIST_FINISHED  = Client.GetJobList( Application = "vasp535", State = "finished", Limit=1024);
    N_FINISHED = LIST_FINISHED[ 'LGI' ][ 'response' ][ 'number_of_jobs' ];

    if (N_FINISHED > 1):
      #for JOB_FINISHED in LIST_FINISHED[ 'LGI' ][ 'response' ][ 'job' ][ : ][ 'job' ]:
      for job_num in range(0, N_FINISHED):
 
        #GET THE JOB ID  
        JOB_FINISHED   = LIST_FINISHED[ 'LGI' ][ 'response' ][ 'job' ][ job_num ][ 'job' ];                   
        job_id         = JOB_FINISHED[ 'job_id' ]
        job_specifics  = JOB_FINISHED[ 'job_specifics' ]
        project        = job_specifics[ 'project' ]

        if ( project == "PES" ):
          repository_url = job_specifics[ 'repository_url' ] 
          folder         = job_specifics[ 'foldername' ]
          func           = job_specifics[ 'functional' ] 

          #only do something if the job is from batch 
          if ( func == functional ):
            #TRANSFER FILES
            #CHANGE THE DIRECTORY  
            os.chdir("LGI_OUTPUT");
            #MAKE A NEW DIRECTORY
            os.mkdir("%s" %(folder));
            os.chdir("%s" %(folder));
            #TRANFER FILE
            #Client.LGI_filetransfer download repository_url OUTCAR OSZICAR POSCAR vasprun.xml ;
            print "downloading: ", repository_url
            FileTransferClient = LGI.LGI_Client( URL = repository_url );
            FileTransferClient.DownLoadFiles( [ "OUTCAR", "OSZICAR", "CHGCAR", "POSCAR", "vasprun.xml" ], "./" );
            print "deleting job nr ", job_id
            Client.DeleteJob( job_id );
            del FileTransferClient;
            #GO BACK TO WORKING DIRECTORY
            os.chdir(CURRENT_DIRECTORY);




# FUNCTION ENDS HERE
#----------------------------------------------------------------------------------------------------------

#ASK FOR THE CURRENT DIRECTORY
CURRENT_DIRECTORY = os.getcwd()

project    = "PES"
functional = "Au-B86SRP68-DF2"
Queue      = "long"
maxwalltime= "14:00:00"
maxram     = "60"
Client     = LGI.LGI_Client();


#atomic locations
location    = [ "0.0 0.0 0.0 0.0", "0.5 0.0 0.0 0.0", "0.66666666 0.33333333 0.0 0.0", "0.33333333 0.16666666 0.0 0.0", "0.5 0.16666666 0.0 0.0", "0.16666666 0.0 0.0 0.0", "0.33333333 0.0 0.0 0.0", "0.16666666 -0.16666666 0.0 0.0", "0.33333333 -0.16666666 0.0 0.0", "0.33333333 -0.33333333 0.0 0.0" ]
ZrangeALL   = [ -1.133, -1.195, -1.06, -0.925, -0.79, -0.655, -0.52, -0.385, -0.29, -0.25, -0.155, -0.115, -0.1, 0.0, 0.1, 0.115, 0.155, 0.25, 0.29, 0.385, 0.425, 0.56, 0.695, 0.83, 0.965, 1.1, 1.235, 1.37, 1.505, 1.64, 1.775, 1.91, 2.045, 2.18, 2.315, 2.45, 2.585, 2.72, 2.855, 2.9, 3.125, 3.26, 3.395, 3.53, 3.665, 3.8, 3.935, 4.07, 4.205, 4.34, 4.475, 4.61, 4.745, 4.88, 5.0, 5.15, 5.3, 5.45, 5.6, 5.75, 5.9, 6.05, 6.20, 6.35, 6.50, 6.65, 6.9, 7.2, 7.5, 7.8, 8.2, 8.5, 9.0 ]
ZrangeTOP   = [ 0, -1.133, -1.195, -1.06, -1.000, -0.975, -0.950, -0.925, -0.900, -0.875, -0.850, -0.825, -0.800, -0.775, -0.750, -0.725, -0.700, -0.675, -0.650, -0.625, -0.600, -0.575, -0.550, -0.525, -0.500, -0.475, -0.450, -0.425, -0.400, -0.375, -0.350, -0.325, -0.300, -0.275, -0.250, -0.225, -0.200, -0.175, -0.150, -0.125, -0.100, -0.075, -0.050, -.025,  0.025, 0.050, 0.075, 0.100, 0.125, 0.150, 0.175, 0.200, 0.225, 0.250, 0.275, 0.300, 0.325, 0.350, 0.375, 0.400, 0.425, 0.450, 0.475, 0.500, 0.525, 0.550, 0.575, 0.600, 0.625, 0.650, 0.675, 0.700, 0.725, 0.750, 0.775, 0.800, 0.825, 0.850, 0.875, 0.900, 0.925, 0.950, 0.975, 1.000, 1.025, 1.050, 1.075, 1.100, 1.125, 1.150, 1.175, 1.200, 1.225, 1.250, 1.275, 1.300, 1.325, 1.350, 1.375, 1.400, 1.425, 1.450, 1.475, 1.500, 1.525, 1.550, 1.575, 1.600, 1.625, 1.650, 1.675, 1.700, 1.725, 1.750, 1.775, 1.800, 1.825, 1.850, 1.875, 1.900, 1.925, 1.950, 1.975, 2.000, 2.025, 2.050, 2.075, 2.100, 2.125, 2.18, 2.315, 2.45, 2.585, 2.72, 2.855, 2.9, 3.125, 3.26, 3.395, 3.53, 3.665, 3.8, 3.935, 4.07, 4.205, 4.34, 4.475, 4.61, 4.745, 4.88, 5.0, 5.15, 5.3, 5.45, 5.6, 5.75, 5.9, 6.05, 6.20, 6.35, 6.50, 6.65, 6.9, 7.2, 7.5, 7.8, 8.2, 8.5, 9.0 ]


NZALL=73
NZTOP=169
Nloc=10
NR=1
MAX_NUM_RUNNING_JOB  = 1000;
MAX_NUM_QUEUED_JOB   = 300;

#os.mkdir("LGI_OUTPUT");
COUNT = 0;
COUNTFINISH = 0

start_val = [0, 0]

###################################################################################################################################################################
###################################################################################################################################################################
#TOP site
loc = 0
for z in range(0,NZTOP):
      print "now at iteration:"
      R = 0.0
      #folder name we are going to give to job_specifics together with functional
      foldername = "ATsite{0}z{1}".format(loc,z)
      print "functional= ", functional, " loc= ", loc, " location= ", location[loc], " z= ", z, " Z= ", ZrangeTOP[z], " foldername= ", foldername
      #CREATE A POSCAR FILE
      create_poscar_file(location[loc], ZrangeTOP[z], R)


      # FIRST: ASK LGI HOW MANY JOBS ARE RUNNING
      #        AND HOW MANY JOBS ARE QUEUED
      # IF THE NUMBER OF QUEUED JOBS IS LARGER THEN MAX_NUM_QUEUED_JOB
      # THEN FALL ASLEEP, OTHERWISE CONTINUE WITH SUBMITTING JOBS
      CONTINUE_VAR = 1 ;
      while CONTINUE_VAR == 1 :
        LIST_QUEUED  = Client.GetJobList( State = "queued", Limit=0 );
        LIST_RUNNING = Client.GetJobList( State = "running", Limit=0);
        N_QUEUED     = LIST_QUEUED[ 'LGI' ][ 'response' ][ 'number_of_jobs' ] ;
        N_RUNNING    = LIST_RUNNING[ 'LGI' ][ 'response' ][ 'number_of_jobs' ];
        print "queued:", N_QUEUED, "running: ", N_RUNNING
        #IF THE NUMBER OF QUEUED JOBS IS SMALLER THAN 
        #if (N_QUEUED < MAX_NUM_QUEUED_JOB and N_RUNNING < MAX_NUM_RUNNING_JOB):
        if (N_QUEUED + N_RUNNING < MAX_NUM_QUEUED_JOB + MAX_NUM_RUNNING_JOB):
           CONTINUE_VAR = 0;
        else:        
           time.sleep(600);  

      #IF THERE ARE ABORTED JOBS THEN DELETE THEM
      LIST_ABORTED  = Client.GetJobList( Application = "vasp535", State = "aborted", Limit=1024);
      N_ABORTED = LIST_ABORTED[ 'LGI' ][ 'response' ][ 'number_of_jobs' ];
      if N_ABORTED > 1:
        for job_num in range(0, N_ABORTED):
          JOB_ABORTED = LIST_ABORTED[ 'LGI' ][ 'response' ][ 'job' ][ job_num ][ 'job' ];
          job_id = JOB_ABORTED[ 'job_id' ];
          job_specifics = JOB_ABORTED[ 'job_specifics' ];
          repository_url = job_specifics[ 'repository_url' ] ;
          Client.DeleteJob( job_id );

      ## SECOND: CREATE AND SUBMIT A JOB  
      JOB = Client.SubmitJob( 
      Application     = "vasp535", 
      TargetResources = "mark@erc2.wks.gorlaeus.net,mark@erc1.wks.gorlaeus.net,mark@octo.wks.gorlaeus.net",
      #TargetResources = "mark@erc1.wks.gorlaeus.net",
      FileList        = [ "./STANDARD/INCAR", "./STANDARD/POTCAR", "./POSCAR", "./STANDARD/KPOINTS", "./STANDARD/vdw_kernel.bindat", "./STANDARD/XCFUNC" ], 
      #now job specifics -- here we can give specifiers for the job in xml format
      JobSpecifics    = "<functional> {0} </functional> <foldername> {1} </foldername> <walltime> {2} </walltime> <mem> {3} </mem> <project> {4} </project> <Queue> {5} </Queue>".format(functional, foldername, maxwalltime, maxram, project, Queue) )
      
#      print "submitted: ", JOB;

      COUNT = COUNT + 1;         
      print " Number of Jobs submitted ", COUNT

     
      #write restart file
      fout_file = open("restart_file", "w");
      fout_file.write("%d %d" %(loc, z)); 
      fout_file.close();

      #now check for finished jobs
      check_finished(CURRENT_DIRECTORY, Client, functional )

###################################################################################################################################################################
###################################################################################################################################################################
#all other sites
for loc in range(1, Nloc):
  for z in range(0, NZALL):
   
      print "now at iteration:"
      R = 0.0
      #folder name we are going to give to job_specifics together with functional
      foldername = "ATsite{0}z{1}".format(loc,z)
      print "functional= ", functional, " loc= ", loc, " location= ", location[loc], " z= ", z, " Z= ", ZrangeALL[z], " foldername= ", foldername
      #CREATE A POSCAR FILE
      create_poscar_file(location[loc], ZrangeALL[z], R)


      # FIRST: ASK LGI HOW MANY JOBS ARE RUNNING
      #        AND HOW MANY JOBS ARE QUEUED
      # IF THE NUMBER OF QUEUED JOBS IS LARGER THEN MAX_NUM_QUEUED_JOB
      # THEN FALL ASLEEP, OTHERWISE CONTINUE WITH SUBMITTING JOBS
      CONTINUE_VAR = 1 ;
      while CONTINUE_VAR == 1 :
        LIST_QUEUED  = Client.GetJobList( State = "queued", Limit=0 );
        LIST_RUNNING = Client.GetJobList( State = "running", Limit=0);
        N_QUEUED     = LIST_QUEUED[ 'LGI' ][ 'response' ][ 'number_of_jobs' ] ;
        N_RUNNING    = LIST_RUNNING[ 'LGI' ][ 'response' ][ 'number_of_jobs' ];
        print "queued:", N_QUEUED, "running: ", N_RUNNING
        #IF THE NUMBER OF QUEUED JOBS IS SMALLER THAN 
        #if (N_QUEUED < MAX_NUM_QUEUED_JOB and N_RUNNING < MAX_NUM_RUNNING_JOB):
        if (N_QUEUED + N_RUNNING < MAX_NUM_QUEUED_JOB + MAX_NUM_RUNNING_JOB):
           CONTINUE_VAR = 0;
        else:        
           time.sleep(600);  

      #IF THERE ARE ABORTED JOBS THEN DELETE THEM
      LIST_ABORTED  = Client.GetJobList( Application = "vasp535", State = "aborted", Limit=1024);
      N_ABORTED = LIST_ABORTED[ 'LGI' ][ 'response' ][ 'number_of_jobs' ];
      if N_ABORTED > 1:
        for job_num in range(0, N_ABORTED):
          JOB_ABORTED = LIST_ABORTED[ 'LGI' ][ 'response' ][ 'job' ][ job_num ][ 'job' ];
          job_id = JOB_ABORTED[ 'job_id' ];
          job_specifics = JOB_ABORTED[ 'job_specifics' ];
          repository_url = job_specifics[ 'repository_url' ] ;
          Client.DeleteJob( job_id );

      ## SECOND: CREATE AND SUBMIT A JOB  
      JOB = Client.SubmitJob( 
      Application     = "vasp535", 
      TargetResources = "mark@erc2.wks.gorlaeus.net,mark@erc1.wks.gorlaeus.net,mark@octo.wks.gorlaeus.net",
      #TargetResources = "mark@erc1.wks.gorlaeus.net",
      FileList        = [ "./STANDARD/INCAR", "./STANDARD/POTCAR", "./POSCAR", "./STANDARD/KPOINTS", "./STANDARD/vdw_kernel.bindat", "./STANDARD/XCFUNC" ], 
      #now job specifics -- here we can give specifiers for the job in xml format
      JobSpecifics    = "<functional> {0} </functional> <foldername> {1} </foldername> <walltime> {2} </walltime> <mem> {3} </mem> <project> {4} </project> <Queue> {5} </Queue>".format(functional, foldername, maxwalltime, maxram, project, Queue) )
      
#      print "submitted: ", JOB;

      COUNT = COUNT + 1;         
      print " Number of Jobs submitted ", COUNT

     
      #write restart file
      fout_file = open("restart_file", "w");
      fout_file.write("%d %d" %(loc, z)); 
      fout_file.close();

      #now check for finished jobs
      check_finished(CURRENT_DIRECTORY, Client, functional )
###################################################################################################################################################################
###################################################################################################################################################################
print
print "entering retrieval loop"
CONTINUE_VAR = 1 ;
while CONTINUE_VAR == 1 :
  check_finished(CURRENT_DIRECTORY, Client, functional )
  print "Going to sleep ......"
  time.sleep(1800);     


